VERSION 5.00
Begin VB.UserControl EzFrame 
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ControlContainer=   -1  'True
   ScaleHeight     =   240
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   320
End
Attribute VB_Name = "EzFrame"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Enum enAllignment
    ezLeft = 0
    ezCenter
    ezRight
End Enum
Enum enBorderStyle
    ezNone = 0
    ezFlat
    ezRaise
    ezInset
End Enum
Enum enButtonState
    ezNormal = vbWhite
    ezOver = vbYellow
    ezPressed = &H8000000C
    EzClicked = vbBlack
End Enum

'Default Property Values:
Const m_def_CloseButton = True
Const m_def_Allignment = ezLeft
Const m_def_BackColor = &H80000001
Const m_def_BorderStyle = ezFlat
Const m_def_Caption = "EzFrame"
Const m_def_ControlFrame = False
Const m_def_ForeColor = &HFFFFFF
'Property Variables:
Dim m_CloseButton As Boolean
Dim m_Allignment As enAllignment
Dim m_BackColor As OLE_COLOR
Dim m_BorderStyle As enBorderStyle
Dim m_Caption As String
Dim m_ControlFrame As Boolean
Dim m_ForeColor As OLE_COLOR

'Added manually
Dim m_BorderStyleTemp As enBorderStyle
Dim m_MinButton As enButtonState
Dim m_RestoreButton As enButtonState
Dim m_ClosedButton As enButtonState
Dim m_OrX As Single
Dim m_OrY As Single

'Event Declarations:
Event FrameClose()
Event Minimize()
Event Restore()


'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,Enabled
Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Returns/sets a value that determines whether an object can respond to user-generated events."
    Enabled = UserControl.Enabled
End Property

Public Property Let Enabled(ByVal New_Enabled As Boolean)
    UserControl.Enabled() = New_Enabled
    PropertyChanged "Enabled"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=0,0,0,True
Public Property Get CloseButton() As Boolean
    CloseButton = m_CloseButton
End Property

Public Property Let CloseButton(ByVal New_CloseButton As Boolean)
    m_CloseButton = New_CloseButton
    PropertyChanged "CloseButton"
    sDrawBox
End Property
'
''WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
''MemberInfo=14,0,0,0
Public Property Get Allignment() As enAllignment
    Allignment = m_Allignment
End Property
Public Property Let Allignment(ByVal New_Allignment As enAllignment)
    m_Allignment = New_Allignment
    PropertyChanged "Allignment"
    sDrawBox
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=10,0,0,0
Public Property Get BackColor() As OLE_COLOR
    BackColor = m_BackColor
End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
    m_BackColor = New_BackColor
    PropertyChanged "BackColor"
    sDrawBox
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=14,0,0,0
Public Property Get BorderStyle() As enBorderStyle
    BorderStyle = m_BorderStyle
End Property

Public Property Let BorderStyle(ByVal New_BorderStyle As enBorderStyle)
    m_BorderStyle = New_BorderStyle
    PropertyChanged "BorderStyle"
    sDrawBox
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=13,0,0,EzFrame
Public Property Get Caption() As String
    Caption = m_Caption
End Property

Public Property Let Caption(ByVal New_Caption As String)
    m_Caption = New_Caption
    PropertyChanged "Caption"
    sDrawBox
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=14,0,0,False
Public Property Get ControlFrame() As Boolean
    ControlFrame = m_ControlFrame
End Property

Public Property Let ControlFrame(ByVal New_ControlFrame As Boolean)
    m_ControlFrame = New_ControlFrame
    PropertyChanged "ControlFrame"
    sDrawBox
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=10,0,0,0
Public Property Get ForeColor() As OLE_COLOR
    ForeColor = m_ForeColor
End Property

Public Property Let ForeColor(ByVal New_ForeColor As OLE_COLOR)
    m_ForeColor = New_ForeColor
    PropertyChanged "ForeColor"
    sDrawBox
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=8
Public Function Show() As Long
    m_RestoreButton = EzClicked
    m_MinButton = ezNormal
    m_ClosedButton = ezNormal
    sDrawRest EzClicked
    sDrawMin m_MinButton
    sDrawClose m_ClosedButton
    UserControl.Height = m_OrY
    UserControl.Width = m_OrX
    RaiseEvent Restore
End Function

Private Sub UserControl_Initialize()
    m_ClosedButton = ezNormal
    m_MinButton = ezNormal
    m_RestoreButton = EzClicked
End Sub

'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
    m_CloseButton = m_def_CloseButton
    m_Allignment = m_def_Allignment
    m_BackColor = m_def_BackColor
    m_BorderStyle = m_def_BorderStyle
    m_Caption = Ambient.DisplayName
    m_ControlFrame = m_def_ControlFrame
    m_ForeColor = m_def_ForeColor
    m_OrX = UserControl.Width
    m_OrY = UserControl.Height
    m_FrameState = m_def_FrameState
End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Me.ControlFrame Then
        sDrawMin m_MinButton
        sDrawRest m_RestoreButton
        sDrawClose m_ClosedButton
        If Y > 6 And Y < TextHeight(Me.Caption) + 3 Then
            Select Case X
            Case UserControl.ScaleWidth - 45 To UserControl.ScaleWidth - 35
                If m_MinButton <> EzClicked Then sDrawMin ezPressed
            Case UserControl.ScaleWidth - 33 To UserControl.ScaleWidth - 23
                If m_RestoreButton <> EzClicked Then sDrawRest ezPressed
            Case UserControl.ScaleWidth - 21 To UserControl.ScaleWidth - 11
                If Not m_CloseButton Then Exit Sub
                If m_ClosedButton <> EzClicked Then sDrawClose ezPressed
            End Select
        End If
    End If
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Me.ControlFrame Then
        sDrawMin m_MinButton
        sDrawRest m_RestoreButton
        sDrawClose m_ClosedButton
        If Y > 6 And Y < TextHeight(Me.Caption) + 3 Then
            Select Case X
            Case UserControl.ScaleWidth - 45 To UserControl.ScaleWidth - 35
                If m_MinButton <> EzClicked Then sDrawMin ezOver
            Case UserControl.ScaleWidth - 33 To UserControl.ScaleWidth - 23
                If m_RestoreButton <> EzClicked Then sDrawRest ezOver
            Case UserControl.ScaleWidth - 21 To UserControl.ScaleWidth - 11
                If Not m_CloseButton Then Exit Sub
                If m_ClosedButton <> EzClicked Then sDrawClose ezOver
            End Select
        End If
    End If
End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Me.ControlFrame Then
        sDrawMin m_MinButton
        sDrawRest m_RestoreButton
        sDrawClose m_ClosedButton
        If Y > 6 And Y < TextHeight(Me.Caption) + 3 Then
            Select Case X
            Case UserControl.ScaleWidth - 45 To UserControl.ScaleWidth - 35
                If m_MinButton <> EzClicked Then
                    m_MinButton = EzClicked
                    m_RestoreButton = ezNormal
                    sDrawMin EzClicked
                    fMinimize
                    sDrawRest m_RestoreButton
                End If
            Case UserControl.ScaleWidth - 33 To UserControl.ScaleWidth - 23
                If m_RestoreButton <> EzClicked Then
                    Show
                End If
            Case UserControl.ScaleWidth - 21 To UserControl.ScaleWidth - 11
                If Not m_CloseButton Then Exit Sub
                If m_ClosedButton <> EzClicked Then
                    m_ClosedButton = EzClicked
                    sDrawClose EzClicked
                    fClose
                End If
            End Select
        End If
    End If
End Sub

Private Sub UserControl_Paint()
    sDrawBox

End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

    UserControl.Enabled = PropBag.ReadProperty("Enabled", True)
    m_CloseButton = PropBag.ReadProperty("CloseButton", m_def_CloseButton)
    m_Allignment = PropBag.ReadProperty("Allignment", m_def_Allignment)
    m_BackColor = PropBag.ReadProperty("BackColor", m_def_BackColor)
    m_BorderStyle = PropBag.ReadProperty("BorderStyle", m_def_BorderStyle)
    m_Caption = PropBag.ReadProperty("Caption", m_def_Caption)
    m_ControlFrame = PropBag.ReadProperty("ControlFrame", m_def_ControlFrame)
    m_ForeColor = PropBag.ReadProperty("ForeColor", m_def_ForeColor)
    m_FrameState = PropBag.ReadProperty("FrameState", m_def_FrameState)
End Sub

Private Sub UserControl_Resize()
    If m_ClosedButton = EzClicked Then
        UserControl.Height = 0
        UserControl.Width = 0
    End If
    sDrawBox
End Sub

Private Sub UserControl_Show()
    sDrawBox
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

    Call PropBag.WriteProperty("Enabled", UserControl.Enabled, True)
    Call PropBag.WriteProperty("CloseButton", m_CloseButton, m_def_CloseButton)
    Call PropBag.WriteProperty("Allignment", m_Allignment, m_def_Allignment)
    Call PropBag.WriteProperty("BackColor", m_BackColor, m_def_BackColor)
    Call PropBag.WriteProperty("BorderStyle", m_BorderStyle, m_def_BorderStyle)
    Call PropBag.WriteProperty("Caption", m_Caption, m_def_Caption)
    Call PropBag.WriteProperty("ControlFrame", m_ControlFrame, m_def_ControlFrame)
    Call PropBag.WriteProperty("ForeColor", m_ForeColor, m_def_ForeColor)
    Call PropBag.WriteProperty("FrameState", m_FrameState, m_def_FrameState)
End Sub
'Close Button Clicked
Private Function fClose()
    If m_CloseButton Then
        If m_MinButton = ezNormal Then fMinimize
        UserControl.Height = 0
        UserControl.Width = 0
        RaiseEvent FrameClose
    End If

End Function
'Minimize Button Clicked
Private Function fMinimize()
    m_OrY = UserControl.Height
    m_OrX = UserControl.Width
    UserControl.Height = (TextHeight(Me.Caption) + 9) * 15
    RaiseEvent Minimize
End Function
Private Sub sDrawBox()
    With UserControl
        Cls
        Select Case Me.BorderStyle
        Case ezFlat
            .ForeColor = &HFFFFFF
            Line (1, 1)-(.ScaleWidth - 1, 1)
            Line (1, 1)-(1, .ScaleHeight - 1)
            Line (1, .ScaleHeight - 1)-(.ScaleWidth - 1, .ScaleHeight - 1)
            Line (.ScaleWidth - 1, 1)-(.ScaleWidth - 1, .ScaleHeight - 1)
        Case ezRaise
            .ForeColor = &HFFFFFF
            Line (1, 1)-(.ScaleWidth - 1, 1)
            Line (1, 1)-(1, .ScaleHeight - 1)
            .ForeColor = &H8000000C
            Line (1, .ScaleHeight - 1)-(.ScaleWidth - 1, .ScaleHeight - 1)
            Line (.ScaleWidth - 1, 1)-(.ScaleWidth - 1, .ScaleHeight - 1)
        Case ezInset
            .ForeColor = &H8000000C
            Line (1, 1)-(.ScaleWidth - 1, 1)
            Line (1, 1)-(1, .ScaleHeight - 1)
            .ForeColor = &HFFFFFF
            Line (1, .ScaleHeight - 1)-(.ScaleWidth - 1, .ScaleHeight - 1)
            Line (.ScaleWidth - 1, 1)-(.ScaleWidth - 1, .ScaleHeight - 1)
        Case ezNone
            .ForeColor = .BackColor
            Line (1, 1)-(.ScaleWidth - 1, 1)
            Line (1, 1)-(1, .ScaleHeight - 1)
            Line (1, .ScaleHeight - 1)-(.ScaleWidth - 1, .ScaleHeight - 1)
            Line (.ScaleWidth - 1, 1)-(.ScaleWidth - 1, .ScaleHeight - 1)
        End Select
    End With
    sDrawCaption
End Sub

Private Sub sDrawCaption()
Dim i As Integer
    With UserControl
    'drawcaption box
        .ForeColor = Me.BackColor
        .FillColor = Me.BackColor
        .FillStyle = vbSolid
        If Me.Enabled Then
            m_BackColorTemo = .ForeColor
        End If
        For i = 3 To TextHeight(Me.Caption) + 6
            Line (3, i)-(.ScaleWidth - 3, i), Me.BackColor, BF
        Next
        If Me.ControlFrame Then
            sDrawMin m_MinButton
            sDrawRest m_RestoreButton
            sDrawClose m_ClosedButton
        End If
    'draw caption
        .ForeColor = Me.ForeColor
        Select Case Me.Allignment
        Case ezLeft
            .CurrentX = 8
            .CurrentY = 6
            Print Me.Caption
        Case ezCenter
            .CurrentX = ((.ScaleWidth / 2) - 4) - (TextWidth(Me.Caption) / 2)
            .CurrentY = 6
            Print Me.Caption
        Case ezRight
            .CurrentX = (.ScaleWidth - 8) - TextWidth(Me.Caption)
            .CurrentY = 6
            Print Me.Caption
        End Select
    End With
End Sub
Private Sub sDrawClose(sState As enButtonState)
Dim i As Integer
    With UserControl
            .ForeColor = sState
            If m_CloseButton = False Then .ForeColor = ezPressed '&H8000000C
            Line (.ScaleWidth - 19, 6)-(.ScaleWidth - 9, 6)
            Line (.ScaleWidth - 9, 6)-(.ScaleWidth - 9, TextHeight(Me.Caption) + 3)
            Line (.ScaleWidth - 9, TextHeight(Me.Caption) + 3)-(.ScaleWidth - 19, TextHeight(Me.Caption) + 3)
            Line (.ScaleWidth - 19, TextHeight(Me.Caption) + 3)-(.ScaleWidth - 19, 6)
            For i = 8 To TextHeight(Me.Caption) + 1
                Line (.ScaleWidth - 17, i)-(.ScaleWidth - 10, i)
            Next
    End With
End Sub
Private Sub sDrawMin(sState As enButtonState)
    With UserControl
            .ForeColor = sState
            Line (.ScaleWidth - 43, 6)-(.ScaleWidth - 33, 6)
            Line (.ScaleWidth - 33, 6)-(.ScaleWidth - 33, TextHeight(Me.Caption) + 3)
            Line (.ScaleWidth - 33, TextHeight(Me.Caption) + 3)-(.ScaleWidth - 43, TextHeight(Me.Caption) + 3)
            Line (.ScaleWidth - 43, TextHeight(Me.Caption) + 3)-(.ScaleWidth - 43, 6)
            Line (.ScaleWidth - 35, TextHeight(Me.Caption))-(.ScaleWidth - 42, TextHeight(Me.Caption))
            Line (.ScaleWidth - 35, TextHeight(Me.Caption) + 1)-(.ScaleWidth - 42, TextHeight(Me.Caption) + 1)
    End With
End Sub
Private Sub sDrawRest(sState As enButtonState)
    With UserControl
            .ForeColor = sState
            Line (.ScaleWidth - 31, 6)-(.ScaleWidth - 21, 6)
            Line (.ScaleWidth - 21, 6)-(.ScaleWidth - 21, TextHeight(Me.Caption) + 3)
            Line (.ScaleWidth - 21, TextHeight(Me.Caption) + 3)-(.ScaleWidth - 31, TextHeight(Me.Caption) + 3)
            Line (.ScaleWidth - 31, TextHeight(Me.Caption) + 3)-(.ScaleWidth - 31, 6)
            Line (.ScaleWidth - 23, 8)-(.ScaleWidth - 30, 8)
            Line (.ScaleWidth - 23, 9)-(.ScaleWidth - 30, 9)
    End With
End Sub
